;;; DO NOT MODIFY THIS FILE
(if (featurep 'latin-euro-standards-autoloads) (error "Already loaded"))

;;;### (autoloads nil "_pkg" "latin-euro-standards/_pkg.el")

(package-provide 'latin-euro-standards :version 1.09 :author-version "1.09" :type 'regular)

;;;***

;;;### (autoloads nil "latin-euro-latin10" "latin-euro-standards/latin-euro-latin10.el")

(unless (find-charset 'latin-iso8859-16) (make-charset 'latin-iso8859-16 "ISO8859-16 (Latin 10)" '(short-name "Latin-10" long-name "ISO8859-16 (Latin 10)" registry "iso8859-16" dimension 1 columns 1 chars 96 final ?f graphic 1 direction l2r)) (loop for c from 64 to 127 do (modify-syntax-entry (make-char 'latin-iso8859-16 c) "w")) (loop for c in '(161 162 163 166 168 170 172 174 175 179 180 181 184 185 186 188 189 190 191) do (modify-syntax-entry (make-char 'latin-iso8859-16 c) "w")))

(unless (find-coding-system 'iso-8859-16) (make-coding-system 'iso-8859-16 'iso2022 "MIME ISO-8859-16" '(charset-g0 ascii charset-g1 latin-iso8859-16 charset-g2 t charset-g3 t mnemonic "MIME/Ltn-10")))

(unless (assoc "Latin-10" language-info-alist) (defun setup-latin10-environment nil "Set up multilingual environment (MULE) for European Latin-10 users." (interactive) (set-language-environment "Latin-10")) (set-language-info-alist "Latin-10" (backquote ((charset ascii latin-iso8859-16) (coding-system iso-8859-16) (coding-priority iso-8859-16) (input-method . "latin-10-prefix") (sample-text \, (format "Hey, if you know Romanian, send sample encoded text (eg, using \"comma-below\"\ncharacters) to xemacs-beta@xemacs.org.  Please use a MIME\napplication/octet-stream attachment if possible.")) (documentation . "This is a generic language environment for Latin-10 (ISO-8859-16).  It\nsupports Romanian and most Western European languages."))) '("European")))

;;;***

;;;### (autoloads nil "latin-euro-latin8" "latin-euro-standards/latin-euro-latin8.el")

(defvar latin-euro-recognize-safe-charsets (condition-case nil (progn (coding-system-property (find-coding-system 'iso-8859-1-unix) 'safe-charsets) t) (error nil)) "\
t if this XEmacs understands the `safe-charsets' coding-system property.")

(unless (find-charset 'latin-iso8859-14) (make-charset 'latin-iso8859-14 "ISO8859-14 (Latin 8)" '(short-name "Latin-8" long-name "ISO8859-16 (Latin 8)" registry "iso8859-14" dimension 1 columns 1 chars 96 final ?_ graphic 1 direction l2r)) (loop for c from 32 to 127 do (modify-syntax-entry (make-char 'latin-iso8859-14 c) "w")) (loop for c in '(163 167 169 173 174 182) do (modify-syntax-entry (make-char 'latin-iso8859-14 c) "_")))

(unless (find-coding-system 'iso-8859-14) (make-coding-system 'iso-8859-14 'iso2022 "MIME ISO-8859-14" (backquote (charset-g0 ascii charset-g1 latin-iso8859-14 charset-g2 t charset-g3 t mnemonic "MIME/Ltn-8" (\,@ (if latin-euro-recognize-safe-charsets '(safe-charsets (ascii control-1 latin-iso8859-14))))))))

(unless (assoc "Latin-8" language-info-alist) (defun setup-latin8-environment nil "Set up multilingual environment (MULE) for European Latin-8 users." (interactive) (set-language-environment "Latin-8")) (set-language-info-alist "Latin-8" (backquote ((charset ascii latin-iso8859-14) (coding-system iso-8859-14) (coding-priority iso-8859-14) (input-method . "latin-8-prefix") (sample-text \, (apply 'format "Following is the first paragraph of Myles na gCopaleen's An B%cal Bocht, %c\nEibhl%cn N%c Nuall%cin, 1941, 1999.  The first asterisked word is a rendering\nof \"diversions\" in Irish orthography, and the second \"adventures\":\n\n\"T%c na nithe at%c luaithe agam sa scr%cbhinn seo %c gcur agam ann de %cr%c go\n%cfuil an saol eile ag druidim liom go sciobtha -- i %cfad uainn go l%cir an\ndrochrud agus n%cr aithn%c an t-ainspiorad mar %cr%cthair m%c -- agus f%cs 'mar\nn%c beidh %cr leith%cid%c ar%cs ann.' Is c%cir cu%c go gcuirf%c ar f%cil don %cuintir\na leanann sinn faisn%cis %cigin ar na dibheairseans* agus na haidbhintiurs** a\nbh%c ann len%cr linn mar nach mbeidh %cr sampla%c ar%cs ann go br%cch agus mar\nnach mbeidh aon saol d againne nach %cfuil anois ann. \"\n\n* scl%cip\n** eachtra%c" (mapcar (function (lambda (code) (make-char 'latin-iso8859-14 code))) '(105 41 109 109 97 97 97 109 97 34 109 34 34 105 97 109 34 97 105 115 97 97 105 109 109 115 109 109 97 53 105 105 109 97 97 109 109 97 34 105 109)))) (documentation . "This is a generic language environment for Latin-8 (ISO-8859-14).  It\nsupports Celtic and most Western European languages."))) '("European")))

;;;***

;;;### (autoloads nil "latin-euro-latin9" "latin-euro-standards/latin-euro-latin9.el")

(unless (find-charset 'latin-iso8859-15) (make-charset 'latin-iso8859-15 "ISO8859-15 (Latin 9)" '(short-name "Latin-9" long-name "ISO8859-15 (Latin 9)" registry "iso8859-15" dimension 1 columns 1 chars 96 final ?b graphic 1 direction l2r)) (loop for c from 64 to 127 do (modify-syntax-entry (make-char 'latin-iso8859-15 c) "w")) (loop for c in '(166 168 180 184 188 189 190) do (modify-syntax-entry (make-char 'latin-iso8859-15 c) "w")) (modify-syntax-entry (make-char 'latin-iso8859-15 32) "w") (modify-syntax-entry (make-char 'latin-iso8859-15 87) "_") (modify-syntax-entry (make-char 'latin-iso8859-15 119) "_"))

(unless (find-coding-system 'iso-8859-15) (make-coding-system 'iso-8859-15 'iso2022 "MIME ISO-8859-15" '(charset-g0 ascii charset-g1 latin-iso8859-15 charset-g2 t charset-g3 t mnemonic "MIME/Ltn-9")))

(unless (assoc "Latin-9" language-info-alist) (defun setup-latin9-environment nil "Set up multilingual environment (MULE) for European Latin-9 users." (interactive) (set-language-environment "Latin-9")) (set-language-info-alist "Latin-9" (backquote ((charset ascii latin-iso8859-15) (coding-system . iso-8859-15) (coding-priority . iso-8859-15) (input-method . "latin-9-prefix") (sample-text \, (format "Hello, Hej, Tere, Hei, Bonjour, Gr%c%c Gott, Ciao, %cHola!, my %c0.02" (make-char 'latin-iso8859-15 124) (make-char 'latin-iso8859-15 95) (make-char 'latin-iso8859-15 33) (make-char 'latin-iso8859-15 36))) (documentation . "This is a generic language environment for Latin-9 (ISO-8859-15).  It\nsupports the Euro and the following languages:\n Danish, Dutch, English, Faeroese, Finnish, French, German, Icelandic,\n Irish, Italian, Norwegian, Portuguese, Spanish, and Swedish.\nWe also have a German specific language environment \"German\"."))) '("European")))

(defun-when-void set-character-of-keysym (keysym character) "Make CHARACTER be inserted when KEYSYM is pressed, \nand the key has been bound to `self-insert-command'.  Contrary to the case\nwith `get-character-of-keysym', KEYSYM may only be a symbol, characters are\nforbidden.  " (check-argument-type 'symbolp keysym) (check-argument-type 'characterp character) (put keysym 'ascii-character character))

(defun-when-void get-character-of-keysym (keysym) "Return the character inserted when KEYSYM is pressed, \nand the key is bound to `self-insert-command'.  " (check-argument-type 'symbolp keysym) (event-to-character (make-event 'key-press (list 'key keysym))))

(flet ((define-keysym-as-char (keysym character) (unless (lookup-key global-map (vector keysym)) (define-key global-map (vector keysym) (function self-insert-command))) (unless (get-character-of-keysym keysym) (set-character-of-keysym keysym character))) (foo (k o) (define-keysym-as-char k (make-char 'latin-iso8859-15 o)))) (foo 'EuroSign 36) (foo 'OE 60) (foo 'oe 61) (foo 'Ydiaeresis 62))

;;;***

(provide 'latin-euro-standards-autoloads)
